VERSION 5.00
Begin VB.Form Main 
   Appearance      =   0  'Flat
   BackColor       =   &H00000000&
   BorderStyle     =   0  'None
   ClientHeight    =   7740
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   9795
   ControlBox      =   0   'False
   DrawWidth       =   2
   FillStyle       =   0  'Solid
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7740
   ScaleWidth      =   9795
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
End
Attribute VB_Name = "Main"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'''''''''''''''''''''''''''''''''''''''''
' Project  : SpiroGraph.vbp
' Developer: Ra Truong
' Creation : 06/12/2001
' Desc     : A dazzling Spirograph lights show
'''''''''''''''''''''''''''''''''''''''''



' Use this instead of the Timer function to gain some speed and display smoothness
Private Declare Function GetTickCount Lib "kernel32" () As Long

' Spirograph properties
Private R1      As Long ' Radius of circle #1
Private R2      As Long ' Radius of circle #2
Private Offset  As Long ' Offset of the two circles
Private CenterX As Long ' Center of the screen in the horizontal direction
Private CenterY As Long ' Center of the screen in the vertical direction

' Program control variables
Private Cancelled As Boolean



Private Sub DrawSpiroGraph()
  Dim x As Long
  Dim y As Long
  Dim t As Long

  
  For t = 0 To (R1 + R2) * 10
    ' The SpiroGraph formula shifted to the center of the canvas
    x = (R1 + R2) * Cos(t) - (R2 + Offset) * Cos(((R1 + R2) / R2) * t) + CenterX
    y = (R1 + R2) * Sin(t) - (R2 + Offset) * Sin(((R1 + R2) / R2) * t) + CenterY
    
    ' Create the random color and show it
    Me.ForeColor = RGB(Rand(0, 255), Rand(0, 255), Rand(0, 255))
    Me.PSet (x * Screen.TwipsPerPixelX, y * Screen.TwipsPerPixelY)
  Next t
End Sub

' Set cancelled flag to true to let the program escapes the main loop
Private Sub Form_Click()
  Cancelled = True
End Sub

Private Sub Form_Load()
  Dim Delta As Long
  
  ' Maximize the window and show it
  Me.WindowState = vbMaximized
  Me.Show
  Cancelled = False
  
  ' Center of the screen
  CenterX = (Me.ScaleWidth / 2) / Screen.TwipsPerPixelX
  CenterY = (Me.ScaleHeight / 2) / Screen.TwipsPerPixelY
  
  ' Spirograph initial values
  R1 = 50
  R2 = 25
  Offset = 40
  Delta = 1
  
  Do
    Me.Cls
    
    ' Adjust the radii to get different patterns
    R2 = R2 + Delta
    If R2 < 10 Then
      Delta = 1
      R1 = Rand(30, 60)
    ElseIf R2 > 100 Then
      Delta = -1
      R1 = Rand(30, 60)
    End If
    If R2 = R1 Then R2 = R2 + Delta
    
    ' Show the new pattern
    Call DrawSpiroGraph
    Wait 200
  Loop While Not Cancelled
  
  ' End this program
  End
End Sub

' Set cancelled flag to true to let the program escapes the main loop
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
  Cancelled = True
End Sub

' Wait MiliSeconds, redraw the spirograph with random colors
Private Sub Wait(ByVal MiliSec As Long)
  Dim EndTime As Long
  
  EndTime = GetTickCount + MiliSec
  Do
    DoEvents
    ' Make the graph twinkling
    Call DrawSpiroGraph
  Loop While GetTickCount < EndTime
End Sub

' Return a random number between the Low and the High
Public Function Rand(ByVal Low As Long, ByVal High As Long) As Long
  Rand = Int((High - Low + 1) * Rnd) + Low
End Function


